diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 2b1da4313..4306355f8 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockSpikes;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 
 public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
     public BlockModelSpikes(Block block) {
@@ -14,7 +15,6 @@ public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int metaData = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.EAST, metaData);
         if(renderBlocks.overrideBlockTexture != null)
@@ -22,8 +22,7 @@ public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
             texture = renderBlocks.overrideBlockTexture;
         }
 
-        block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F);
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
 
         if(BlockSpikes.isSpikesUp(metaData)) {
             float brightness = 1.0f;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
similarity index 59%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index cce007e2a..568febe01 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockStairs;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -18,40 +19,40 @@ public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int hRotation = meta & 0b0011;
         int vRotation = meta & 0b1000;
 
         float stepYOffset = vRotation > 0 ? 0.5f : 0.0f;
 
+        AABB bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
+
         if(hRotation == 0)
         {
-            block.setBlockBounds(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F);
-            renderStandardBlock(tessellator, block, x, y, z);
-            block.setBlockBounds(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         } else
         if(hRotation == 1)
         {
-            block.setBlockBounds(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F);
-            renderStandardBlock(tessellator, block, x, y, z);
-            block.setBlockBounds(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         } else
         if(hRotation == 2)
         {
-            block.setBlockBounds(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F);
-            renderStandardBlock(tessellator, block, x, y, z);
-            block.setBlockBounds(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         } else {
-            block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
-            renderStandardBlock(tessellator, block, x, y, z);
-            block.setBlockBounds(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
-        block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         return true;
     }
 
@@ -67,39 +68,44 @@ public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<
         }
         for(int l = 0; l < 2; l++)
         {
+            AABB bounds;
             if(l == 0)
             {
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
-            }
-            if(l == 1)
-            {
-                block.setBlockBounds(0.0F, 0.0F, 0.5F, 1.0F, 0.5F, 1.0F);
+                bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F);
+            } else {
+                bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.5F, 1.0F, 0.5F, 1.0F);
             }
             GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, -1F, 0.0F);
-            renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+            renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
-            renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+            renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
-            renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
-            renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
-            renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
-            renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
             tessellator.draw();
+
             GL11.glTranslatef(0.5F, 0.5F, 0.5F);
         }
     }
@@ -114,4 +120,9 @@ public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<
     {
         return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).getBlockTexture(blockAccess, x, y, z, side);
     }
+
+    @Override
+    public int renderLayer() {
+        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).renderLayer();
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
similarity index 55%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index dd8670a08..8443494dd 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
@@ -15,8 +16,9 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
     public static final IconCoordinate BLOCK_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:block/texture_missing");
     public static final IconCoordinate BLOCK_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:block/texture_unassigned");
     public IconCoordinate[] atlasIndices = new IconCoordinate[]{BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED};
-    public double[] itemRenderBounds = null;
+    public AABB itemRenderBounds = null;
     public IconCoordinate overbrightTexture = null;
+    public int renderlayer = 0;
 
     public BlockModelStandard(Block block) {
         super(block);
@@ -24,8 +26,7 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        return renderStandardBlock(tessellator, block, x, y, z );
+        return renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
     }
 
     @Override
@@ -41,80 +42,82 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
 		}
 		float yOffset = 0.5F;
 
-		setBlockBoundsForItemRender();
+        AABB bounds = getBlockBoundsForItemRender();
 		GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
+		renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, lightmapCoordinate);
+		GL11.glTranslatef(0.5F, yOffset, 0.5F);
+	}
 
-		if(LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null) {
-			LightmapHelper.setLightmapCoord(lightmapCoordinate);
-		}
+    public void renderBlockWithBounds(Tessellator tessellator, AABB bounds, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        if(LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null) {
+            LightmapHelper.setLightmapCoord(lightmapCoordinate);
+        }
 
-		tessellator.startDrawingQuads();
+        tessellator.startDrawingQuads();
 
-		tessellator.setNormal(0.0f, -1.0f, 0.0f);
-		renderBottomFace(tessellator, block, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+        tessellator.setNormal(0.0f, -1.0f, 0.0f);
+        renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
 
-		tessellator.setNormal(0.0f, 1.0f, 0.0f);
-		renderTopFace(tessellator, block, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+        tessellator.setNormal(0.0f, 1.0f, 0.0f);
+        renderTopFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
 
-		tessellator.setNormal(0.0f, 0.0f, -1.0f);
-		renderNorthFace(tessellator, block, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+        tessellator.setNormal(0.0f, 0.0f, -1.0f);
+        renderNorthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
 
-		tessellator.setNormal(0.0f, 0.0f, 1.0f);
-		renderSouthFace(tessellator, block, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+        tessellator.setNormal(0.0f, 0.0f, 1.0f);
+        renderSouthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
 
-		tessellator.setNormal(-1.0f, 0.0f, 0.0f);
-		renderWestFace(tessellator, block, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+        tessellator.setNormal(-1.0f, 0.0f, 0.0f);
+        renderWestFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
 
-		tessellator.setNormal(1.0f, 0.0f, 0.0f);
-		renderEastFace(tessellator, block, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+        tessellator.setNormal(1.0f, 0.0f, 0.0f);
+        renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
 
-		tessellator.draw();
+        tessellator.draw();
 
-		if(hasOverbright()) {
+        if(hasOverbright()) {
 //			GL11.glDisable(GL11.GL_LIGHTING);
-			
-			brightness = 1.0f;
-			if(renderBlocks.useInventoryTint) {
-				int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
-				float r = (float) (color >> 16 & 0xff) / 255F;
-				float g = (float) (color >> 8 & 0xff) / 255F;
-				float b = (float) (color & 0xff) / 255F;
-				GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-			}else {
-				GL11.glColor4f(brightness, brightness, brightness, alpha);
-			}
 
-			if(LightmapHelper.isLightmapEnabled()) {
-				LightmapHelper.setLightmapCoord(15, 15);
-			}
+            brightness = 1.0f;
+            if(renderBlocks.useInventoryTint) {
+                int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+                float r = (float) (color >> 16 & 0xff) / 255F;
+                float g = (float) (color >> 8 & 0xff) / 255F;
+                float b = (float) (color & 0xff) / 255F;
+                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
+            }else {
+                GL11.glColor4f(brightness, brightness, brightness, alpha);
+            }
 
-			tessellator.startDrawingQuads();
+            if(LightmapHelper.isLightmapEnabled()) {
+                LightmapHelper.setLightmapCoord(15, 15);
+            }
 
-			tessellator.setNormal(0.0f, -1.0f, 0.0f);
-			renderBottomFace(tessellator, block, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.BOTTOM, metadata));
+            tessellator.startDrawingQuads();
 
-			tessellator.setNormal(0.0f, 1.0f, 0.0f);
-			renderTopFace(tessellator, block, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.TOP, metadata));
+            tessellator.setNormal(0.0f, -1.0f, 0.0f);
+            renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.BOTTOM, metadata));
 
-			tessellator.setNormal(0.0f, 0.0f, -1.0f);
-			renderNorthFace(tessellator, block, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.NORTH, metadata));
+            tessellator.setNormal(0.0f, 1.0f, 0.0f);
+            renderTopFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.TOP, metadata));
 
-			tessellator.setNormal(0.0f, 0.0f, 1.0f);
-			renderSouthFace(tessellator, block, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.SOUTH, metadata));
+            tessellator.setNormal(0.0f, 0.0f, -1.0f);
+            renderNorthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.NORTH, metadata));
 
-			tessellator.setNormal(-1.0f, 0.0f, 0.0f);
-			renderWestFace(tessellator, block, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.WEST, metadata));
+            tessellator.setNormal(0.0f, 0.0f, 1.0f);
+            renderSouthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.SOUTH, metadata));
 
-			tessellator.setNormal(1.0f, 0.0f, 0.0f);
-			renderEastFace(tessellator, block, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.EAST, metadata));
+            tessellator.setNormal(-1.0f, 0.0f, 0.0f);
+            renderWestFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.WEST, metadata));
 
-			tessellator.draw();
-			
-//			GL11.glEnable(GL11.GL_LIGHTING);
-		}
+            tessellator.setNormal(1.0f, 0.0f, 0.0f);
+            renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.EAST, metadata));
 
-		GL11.glTranslatef(0.5F, yOffset, 0.5F);
-	}
+            tessellator.draw();
+
+//			GL11.glEnable(GL11.GL_LIGHTING);
+        }
+    }
 
     @Override
     public boolean shouldItemRender3d() {
@@ -150,35 +153,35 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
         return getBlockTextureFromSideAndMetadata(side, meta);
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side, int meta)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side, int meta)
     {
-        return shouldSideBeRendered(blockAccess, x, y, z, side);
+        return shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         Side side1 = Side.getSideById(side);
-        if(side1 == Side.BOTTOM && block.minY > 0.0D)
+        if(side1 == Side.BOTTOM && bounds.minY > 0.0D)
         {
             return true;
         }
-        else if(side1 == Side.TOP && block.maxY < 1.0D)
+        else if(side1 == Side.TOP && bounds.maxY < 1.0D)
         {
             return true;
         }
-        else if(side1 == Side.NORTH && block.minZ > 0.0D)
+        else if(side1 == Side.NORTH && bounds.minZ > 0.0D)
         {
             return true;
         }
-        else if(side1 == Side.SOUTH && block.maxZ < 1.0D)
+        else if(side1 == Side.SOUTH && bounds.maxZ < 1.0D)
         {
             return true;
         }
-        else if(side1 == Side.WEST && block.minX > 0.0D)
+        else if(side1 == Side.WEST && bounds.minX > 0.0D)
         {
             return true;
         }
-        else if(side1 == Side.EAST && block.maxX < 1.0D)
+        else if(side1 == Side.EAST && bounds.maxX < 1.0D)
         {
             return true;
         }
@@ -192,20 +195,26 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
         return true;
     }
     @Override
-    public void setBlockBoundsForItemRender()
+    public AABB getBlockBoundsForItemRender()
     {
         if (itemRenderBounds != null){
-            block.setBlockBounds(
-            itemRenderBounds[0],
-            itemRenderBounds[1],
-            itemRenderBounds[2],
-            itemRenderBounds[3],
-            itemRenderBounds[4],
-            itemRenderBounds[5]);
+            return itemRenderBounds;
         }
+        return super.getBlockBoundsForItemRender();
+    }
+
+    @Override
+    public int renderLayer() {
+        return renderlayer;
     }
+
+    public BlockModelStandard<T> onRenderLayer(int layer) {
+        this.renderlayer = layer;
+        return this;
+    }
+
     public BlockModelStandard<T> withCustomItemBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ){
-        this.itemRenderBounds = new double[]{minX, minY, minZ, maxX, maxY, maxZ};
+        this.itemRenderBounds = AABB.getPermanentBB(minX, minY, minZ, maxX, maxY, maxZ);
         return this;
     }
     public BlockModelStandard<T> withOverbrightTexture(String texture)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
similarity index 77%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
index c75156492..8da732220 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -17,10 +18,10 @@ public class BlockModelStoneMossy<T extends Block> extends BlockModelStandard<T>
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        renderStandardBlock(tessellator, block, x, y, z, 1.0f, 1.0f, 1.0f);
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
+        renderStandardBlock(tessellator, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = mossOverlay;
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, bounds, x, y, z);
         renderBlocks.overrideBlockTexture = null;
         return true;
     }
@@ -38,31 +39,32 @@ public class BlockModelStoneMossy<T extends Block> extends BlockModelStandard<T>
         float b = (float)(color & 0xff) / 255F;
         GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
 
+        AABB bounds = block.getBounds();
         IconCoordinate mossCoord = mossOverlay;
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
similarity index 97%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index c54de360f..94063164c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockTorch;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 
 public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
@@ -14,13 +15,12 @@ public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
             tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-            if(Block.lightEmission[block.id] > 0) {
+            if(Blocks.lightEmission[block.id] > 0) {
                 brightness = 1.0F;
             }
         }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
similarity index 78%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
index b0a2d9837..d3bb1c846 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelTransparent<T extends Block> extends BlockModelStandard<T> {
@@ -10,14 +11,14 @@ public class BlockModelTransparent<T extends Block> extends BlockModelStandard<T
         this.renderInside = renderInside;
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         if(!renderInside && blockAccess.getBlockId(x, y, z) == block.id)
         {
             return false;
         } else
         {
-            return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 0fccd7420..12db78c3e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -19,7 +19,6 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean isUp = BlockTrapDoor.isTrapdoorOpen(metadata);
 
@@ -62,7 +61,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
                 renderBlocks.uvRotateWest = 3;
             }
         }
-        renderStandardBlock(tessellator, block, x, y, z);
+        super.render(tessellator, x, y, z);
         resetRenderBlocks();
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index a7bcd01bf..58c696a32 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -15,7 +15,6 @@ public class BlockModelVeryRotatable<T extends Block> extends BlockModelStandard
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         final Direction dir = BlockTileEntityVeryRotatable.metaToDirection(meta);
 
@@ -23,7 +22,7 @@ public class BlockModelVeryRotatable<T extends Block> extends BlockModelStandard
             renderBlocks.uvRotateSouth = 1;
             renderBlocks.uvRotateNorth = 2;
         }
-        final boolean result = renderStandardBlock(tessellator, block, x, y, z);
+        final boolean result = super.render(tessellator, x, y, z);
         resetRenderBlocks();
 
         return result;
